#!/usr/bin/env python
#-*- coding: ISO-8859-1 -*-

# system modules
import os, sys, string, stat, re, types
from FMWSExceptions import *

class FMWSConfig:
  def __init__(self,iConfig={}):
    """
       Read and parse content of FMWS.conf configuration file
       Comments are started with '#' letter. User can specify login and password
       to provide access to underlying DB, if SQLite is used they're ignored. 
    """
    uFileName=""
    if os.environ.has_key('FMWSHOME'):
       if not os.path.isfile(os.path.join(os.environ['FMWSHOME'],'FMWS.conf')):
          raise FMWSException(args="The '%s' config file does not exists"%os.path.join(os.environ['FMWSHOME'],'FMWS.conf'))
       uFileName=os.path.join(os.environ['FMWSHOME'],'FMWS.conf')
    else:
       raise FMWSException(args="No FMWSHOME environment found")
    self.configFile=uFileName
    if not os.path.isfile(uFileName):
       raise FMWSException(args="The '%s' config file does not exists"%uFileName)
    mode = os.stat(uFileName)[stat.ST_MODE]
    if mode!=33152:
       # mode is not -rw-------
       print "WARNING: permission of %s is set to 0600 mode (-rw-------)"%uFileName
       os.chmod(uFileName,0600)
    iList=['loggerdir','transferdir','verboselevel','maxtransfer']
    self.configDict={}
    for read in open(uFileName).readlines():
        line = string.split(read,"\n")[0]
        if not len(line): continue
        if line[0]=="#": continue
        for item in iList:
            keyword=string.upper(item)
            if re.match(keyword,line):
               self.configDict[item] = string.split(line,"%s="%keyword)[1]
            if iConfig.has_key(item) and iConfig[item]:
               self.configDict[item] = iConfig[item]
  def transferDir(self):
    if not self.configDict.has_key('transferdir'):
       raise FMWSException(args="FMWS.conf, missing TRANSFERDIR parameter")
    return self.configDict['transferdir']
  def loggerDir(self):
    if not self.configDict.has_key('loggerdir'):
       raise FMWSException(args="FMWS.conf, missing LOGGERDIR parameter")
    return self.configDict['loggerdir']
  def verboseLevel(self):
    if not self.configDict.has_key('verboselevel'):
       raise FMWSException(args="FMWS.conf, missing VERBOSELEVEL parameter")
    return self.configDict['verboselevel']
  def maxTransfer(self):
    if not self.configDict.has_key('maxtransfer'):
       raise FMWSException(args="FMWS.conf, missing MAXTRANSFER parameter")
    return self.configDict['maxtransfer']
  
#
# main
#
if __name__ == "__main__":
   fmConfig = FMWSConfig()
   print "Config file",fmConfig.configFile
   print fmConfig.configDict

