#!/usr/bin/env python
#-*- coding: ISO-8859-1 -*-

import cherrypy, os, string, time, urllib, traceback
import logging, logging.handlers

class FMWSLogger:
  """
     FMWSLogger class
  """
  def __init__(self,dir='/tmp',name="Logger",verbose=0):
      """
         Logger constructor. 
         @type  name: string
         @param name: name of the logger, default "Logger"
         @type  verbose: boolean or int
         @param : level of verbosity 
         @rtype : none
         @return: none
      """
      if verbose==1:
         self.logLevel = logging.INFO
      elif verbose==2:
         self.logLevel = logging.DEBUG
      else:
#         self.logLevel = logging.NOTSET
         self.logLevel = logging.WARNING
      self.name = name
      self.dir = dir
      self.logName = os.path.join(dir,'FMWS.log') 
      try:
         if not os.path.isdir(self.dir):
            os.mkdirs(self.dir)
         # check if we can create log file over there
         if not os.path.isfile(self.logName):
            f=open(self.logName,'a')
            f.close()
      except:
         msg="Not enough permissions to create a FMWS log file in '%s'"%self.dir
         raise msg
      hdlr = logging.handlers.TimedRotatingFileHandler( self.logName, 'midnight', 1, 7 )
      formatter = logging.Formatter( '%(asctime)s - %(name)s - %(levelname)s - %(message)s' )
      hdlr.setFormatter( formatter )
      self.loggerHandler=hdlr
      self.setLogger()

  def setLevel(self,level):
      self.logLevel=level

  def getHandler(self):
      return self.loggerHandler

  def getLogLevel(self):
      return self.logLevel

  def writeLog(self,msg):
      """
          Write given message to the logger
          @type  msg: string
          @param msg: message
          @rtype : none
          @return: none
      """
      self.logger.warning(msg)
#      if self.verbose==1:
#         self.logger.info(msg)
#      elif self.verbose>=2:
#         self.logger.debug(msg)
#      else:
#         self.logger.warning(msg)

  def setLogger(self):
      """
         Set logger settings, style, format, verbosity.
         @type  self: class object
         @param self: none 
         @rtype : none
         @return: none
      """
      # Set up the logger with a suitable format
      self.logger = logging.getLogger(self.name)
      self.logger.setLevel(self.logLevel)
      self.logger.addHandler(self.loggerHandler)

def setLogger(loggerName,hdlr,logLevel):
    # set up logging for FileManager
    logging.getLogger(loggerName).setLevel(logLevel)
    logging.getLogger(loggerName).addHandler(hdlr)
